iterations_number = 200
dumping_step = 1

model_type = 'ms'

height = 500
width = 770

environment_density = 0.5

perturbation_density = 3.0
perturbation_radius = 150

----------------------------------------------------------------


particle_velocities = {
    {-1, -1},
    { 1,  1},
    {-1,  1},
    { 1, -1},
}

h = height
w = width
r = perturbation_radius

s = math.pi / 11
e = 1e-4

circle = {}
for a = s, math.pi + e, s do
    circle[#circle + 1] = { h / 2 + r * math.sin(2 * a), w / 2 + r * math.cos(2 * a) }
end

locations = {
    {
        density = environment_density,
        area = {
            { 0,     0     },
            { 0,     h - 1 },
            { h - 1, w - 1 },
            { w - 1, 0     },
        },
    },
    {
        density = perturbation_density,
        area = circle,
    }
}

working_directory = 'results'
models_directory = 'models'
