#pragma once

typedef struct {
    void *handle;
    void (*del) (lua_State *);
    void (*dump) (void *, int);
    void (*step) (void *, int);
    void *_;
} model_t;

model_t *model_new(const char *, lua_State *);
void model_del(model_t *);

void model_step(model_t *, int);
void model_dump(model_t *, int);
