#pragma once

#define map_t(ktype, vtype)\
struct {\
    int size;\
    int real_size;\
    struct {\
        ktype k;\
        vtype v;\
    } *_;\
}

#define map_get(M, K, V) {\
    int map_j = -1;\
    for (int map_i = 0; map_i < M.size; map_i++) {\
        if (M._[map_i].k == K) {\
            map_j = map_i;\
            break;\
        }\
    }\
    if (map_j != -1)\
        V = M._[map_j].v;\
}\

#define map_set(M, K, V) {\
    int map_j = -1;\
    for (int map_i = 0; map_i < M.size; map_i++) {\
        if (M._[map_i].k == K) {\
            map_j = map_i;\
            break;\
        }\
    }\
    if (map_j == -1) {\
        if (M.size + 1 > M.real_size) {\
            if (M.real_size < 1)\
                M.real_size = 1;\
            else\
                M.real_size <<= 1;\
            M._ = realloc(M._, M.real_size * sizeof(__typeof(M._[0])));\
            if (M._ == NULL) abort();\
        }\
        M._[M.size].k = K;\
        M._[M.size].v = V;\
        M.size++;\
    }\
    else\
        M._[map_j].v = V;\
}
